"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const extractor_1 = __importStar(require("./extractor"));
const factory = () => {
    const dependencies = new Map();
    const { extract } = (0, extractor_1.default)();
    const reduce = (acc, result) => {
        let key;
        let value;
        if (result.type === extractor_1.Type.VARIABLE) {
            key = result.result;
            value = dependencies.get(key);
        }
        else if (result.type === extractor_1.Type.OBJECT) {
            value = result.result.reduce(reduce, {});
        }
        if (Array.isArray(acc)) {
            acc.push(value);
        }
        else {
            acc[key] = value;
        }
        return acc;
    };
    const resolve = (resolvable, args) => {
        const extracted = extract(resolvable);
        const resolved = extracted.reduce(reduce, []);
        return resolvable.apply(args, resolved);
    };
    const reset = () => {
        dependencies.clear();
        return context();
    };
    const get = (name) => (dependencies.get(name));
    const set = (name, value) => {
        dependencies.set(name, value);
        return context();
    };
    const init = (input) => {
        for (const [key, value] of Object.entries(input)) {
            set(key, value);
        }
        return context();
    };
    const context = () => ({
        resolve,
        reset,
        get,
        set,
        init,
    });
    return context();
};
exports.default = factory;
