import { Result } from './extractor';
import type { Switch } from './types';
type Callables<T, R> = (...args: Array<{
    [K in keyof T]?: T[K];
}>) => R;
type Resolvable<T, R = unknown> = Callables<T, R>;
type Key<T> = Switch<T, keyof T, string | number>;
type Value<T, K extends Key<T>> = K extends keyof T ? T[K] : any;
type Conr<T extends {} = {}> = {
    resolve: <R>(resolvable: Switch<T, Resolvable<T, R>, any>, args?: unknown) => R;
    get: <K extends Key<T>>(key: K) => Value<T, K>;
    set: <K extends Key<T>>(key: K | string, value: Value<T, K>) => Conr<T>;
    reset: () => Conr<T>;
    init: (input: Partial<T>) => Conr<T>;
};
declare const factory: <T>() => Conr<T>;
export default factory;
export type { Callables, Result, Conr };
